clear

% load data
load mnistSubset

%% Task 1 - Raise your hand when finished.

% Plot the digits
classes = [1,5,10];
figure
figInd = 1;
for ii = classes
    subplot(3, 3, figInd)
    imshow(reshape(X(:, ii + (ii-1)*200), [28,28]))
    figInd = figInd + 1;
    subplot(3, 3, figInd)
    imshow(reshape(X(:, ii + 50 + (ii-1)*200), [28,28]))
    figInd = figInd + 1;
    subplot(3, 3, figInd)
    imshow(reshape(X(:, ii + 100 + (ii-1)*200), [28,28]))
    figInd = figInd + 1;
end
sgtitle('Example Images')

% Look at some singular values
figure
hold all
for ii = classes
    Xi = X(:,trueLabels==ii);
    svals = svd(Xi);
    stem(svals)
end
title('Singular Values')
legend('0', '4', '9')

% Plot requested ratio
figure
hold all
for ii = classes
    Xk = X(:,trueLabels==ii);
    svals = svd(Xk);
    plot(cumsum(svals) / sum(svals))
end
title('Relative energy in singular values 1:K')
legend('0', '4', '9')

%% Task 2 - Raise your hand when finished.
K = 10;
Xtrain = [];
ytrain = [];
Xtest = [];
ytest = [];
for kk = 1:K
    Xk = X(:,trueLabels==kk);
    Xtrain = [Xtrain Xk(:,1:100)];
    Xtest = [Xtest Xk(:,101:end)];
    ytrain = [ytrain; kk*ones(100,1)];
    ytest = [ytest; kk*ones(100,1)];
end

r = 4;
Ufull = trainUoS(Xtrain,ytrain,r);

% Plot a few principal components
Uk = Ufull(:,:,6);
figure()
subplot(1,4,1)
imagesc(reshape(Uk(:,1),28,28))
subplot(1,4,2)
imagesc(reshape(Uk(:,2),28,28))
subplot(1,4,3)
imagesc(reshape(Uk(:,3),28,28))
subplot(1,4,4)
imagesc(reshape(Uk(:,4),28,28))
colormap('gray')
sgtitle('Principal Components')

%% Task 3 - Raise your hand when finished.

% Error for a variety of r values
Nr = 20;
errs = zeros(Nr,1);
for rr = 1:Nr
    Ufull = trainUoS(Xtrain,ytrain,rr);
    estLabels = nsClassify(Xtest,Ufull);
    errs(rr) = sum(estLabels~=ytest)/length(ytest);
    disp(errs(rr))
end

% Show some mislabeled points
errPoints = find(estLabels~=ytest);
Np = 64;    % make sure this is a perfect square
inds = errPoints(round(linspace(1,length(errPoints),Np)));

figure
for ii = 1:Np
    subplot(sqrt(Np), sqrt(Np), ii)
    imshow(reshape(Xtest(:,inds(ii)), [28,28]))
end
sgtitle('Mislabeled Points')
