function Ufull = trainUoS(X,y,r)
% Learn union of r-dimensional subspaces that best fit a dataset from K classes
% 
% Syntax Ufull = 

%
% Inputs:       X is a D x N matrix of training ata
%               y is an N x 1 vector of labels
%               r is the rank/dimension of the subspaces
%
% Outputs:      Ufull is a D x r x K matrix where Ufull(:,:,k) is a basis for
%               

[D,N] = size(X);
K = max(y);

Ufull = zeros(D,r,K);
for kk = 1:K
    Xk = X(:,y==kk);
    [Ufull(:,:,kk),~,~] = svds(Xk,r);
end
